package javax.management.relation;

import java.util.Iterator;
import java.util.Collection;
import com.sun.jmx.mbeanserver.Util;
import java.util.List;
import java.util.ArrayList;

public class RoleList extends ArrayList<Object>
{
    private transient boolean typeSafe;
    private transient boolean tainted;
    private static final long serialVersionUID = 5568344346499649313L;
    
    public RoleList() {
    }
    
    public RoleList(int initialCapacity) {
        super(initialCapacity);
    }
    
    public RoleList(List<Role> c) throws IllegalArgumentException {
        if (c == null) {
            throw new IllegalArgumentException("Null parameter");
        }
        checkTypeSafe(c);
        super.addAll(c);
        return;
    }
    
    public List<Role> asList() {
        if (!this.typeSafe) {
            if (this.tainted) {
                checkTypeSafe(this);
            }
            this.typeSafe = true;
        }
        return (List)Util.cast(this);
    }
    
    public void add(Role e) throws IllegalArgumentException {
        if (e == null) {
            throw new IllegalArgumentException("Invalid parameter");
        }
        super.add(e);
        return;
    }
    
    public void add(int index, Role element) throws IllegalArgumentException, IndexOutOfBoundsException {
        if (element == null) {
            throw new IllegalArgumentException("Invalid parameter");
        }
        super.add(index, element);
        return;
    }
    
    public void set(int index, Role element) throws IllegalArgumentException, IndexOutOfBoundsException {
        if (element == null) {
            throw new IllegalArgumentException("Invalid parameter.");
        }
        super.set(index, element);
        return;
    }
    
    public boolean addAll(RoleList c) throws IndexOutOfBoundsException {
        return c == null || super.addAll(c);
    }
    
    public boolean addAll(int index, RoleList c) throws IllegalArgumentException, IndexOutOfBoundsException {
        if (c == null) {
            throw new IllegalArgumentException("Invalid parameter.");
        }
        return super.addAll(index, c);
    }
    
    @Override
    public boolean add(Object e) {
        if (!this.tainted) {
            this.tainted = isTainted(e);
        }
        if (this.typeSafe) {
            checkTypeSafe(e);
        }
        return super.add(e);
    }
    
    @Override
    public void add(int index, Object element) {
        if (!this.tainted) {
            this.tainted = isTainted(element);
        }
        if (this.typeSafe) {
            checkTypeSafe(element);
        }
        super.add(index, element);
    }
    
    @Override
    public boolean addAll(Collection<?> c) {
        if (!this.tainted) {
            this.tainted = isTainted(c);
        }
        if (this.typeSafe) {
            checkTypeSafe(c);
        }
        return super.addAll(c);
    }
    
    @Override
    public boolean addAll(int index, Collection<?> c) {
        if (!this.tainted) {
            this.tainted = isTainted(c);
        }
        if (this.typeSafe) {
            checkTypeSafe(c);
        }
        return super.addAll(index, c);
    }
    
    @Override
    public Object set(int index, Object element) {
        if (!this.tainted) {
            this.tainted = isTainted(element);
        }
        if (this.typeSafe) {
            checkTypeSafe(element);
        }
        return super.set(index, element);
    }
    
    private static void checkTypeSafe(Object o) {
        try {
            Role role = (Role)o;
        }
        catch (ClassCastException cause) {
            throw new IllegalArgumentException(cause);
        }
    }
    
    private static void checkTypeSafe(Collection<?> collection) {
        try {
            for (Role role : collection) {}
        }
        catch (ClassCastException cause) {
            throw new IllegalArgumentException(cause);
        }
    }
    
    private static boolean isTainted(Object o) {
        try {
            checkTypeSafe(o);
        }
        catch (IllegalArgumentException ex) {
            return true;
        }
        return false;
    }
    
    private static boolean isTainted(Collection<?> collection) {
        try {
            checkTypeSafe(collection);
        }
        catch (IllegalArgumentException ex) {
            return true;
        }
        return false;
    }
}
